     *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                                                                          
     *_> DLTMOD MODULE(@5/@4)                                                                                          
     *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +                                                           
     *_>   DBGVIEW(@9) OPTIMIZE(@8)                                                                                    
     * ---------------------------------------------------------------                                                 
     * Module.: TG0002_M04           Project.....:                                                                     
     * Author.: A. Campin            Date written: 04/03/2005                                                          
     * Purpose: Screen Four. Add/Edit/Display a record to Trigger                                                      
     *            Control Detail.                                                                                      
     * ---------------------------------------------------------------                                                 
     * Called by: TG0002_M03                                                                                           
     * ---------------------------------------------------------------                                                 
     * Revision history:                                                                                               
     *  Project # Pgmr        Date   Desc                                                                              
     *                                                                                                                 
     * End Revision History                                                                                            
     * ---------------------------------------------------------------                                                 
     *                  Standards                                                                                      
     *                  Function Keys.                                                                                 
     *                                                                                                                 
     *  F3  - SAA Exit.                                                                                                
     *  F12 - Previous Screen.                                                                                         
     * ---------------------------------------------------------------                                                 
     *                       Indicators                                                                                
     *                                                                                                                 
     * @@@ Indicators 1 - 25 for data base I/O.                                                                        
     *                                                                                                                 
     * @@@ Indicators 26 - 29 for subfile control.                                                                     
     *                                                                                                                 
     *      26 - Display subfile control.                                                                              
     *      27 - Display subfile.                                                                                      
     *      28 - Clear subfile.                                                                                        
     *      29 - SFLEND enabled.                                                                                       
     *                                                                                                                 
     * @@@ Indicators 30 - 49 display file I/O control.                                                                
     *                                                                                                                 
     * @@@ Indicators 50 - 79 field error indicators.                                                                  
     *                                                                                                                 
     * @@@ Indicators 80 - 94 Condition control.                                                                       
     *                                                                                                                 
     * @@@ Indicators 95 - 99 Scratch indicators.                                                                      
     *                                                                                                                 
     *      95 - Subfile message handler.                                                                              
     *      99 - Scratch indicator.                                                                                    
     * ---------------------------------------------------------------                                                 
      /EJECT                                                                                                            
     h nomain                                                                                                           
                                                                                                                        
     fTG0002_D01cf   e             Workstn InfDs(FI01)                                                                  
     f                                     UsrOpn                                                                       
     f                                     Include(RD01_04:                                                             
     f                                             SFMSG_CTL)                                                           
ts006fTGCTRLD_00uf a e           k Disk    UsrOpn                                                                       
                                                                                                                        
      /copy *libl/qsrcf,cb_Std_Con                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,cb_StdType                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,XVMSGF_PR                                                                                       
                                                                                                                        
      /copy *libl/qsrcf,TG0002_LP                                                                                       
                                                                                                                        
      /Define cb_DisplaySubfileMessages_PR                                                                              
      /copy *libl/qsrcf,CB_DSPSFM                                                                                       
      /Undefine cb_DisplaySubfileMessages_PR                                                                            
                                                                                                                        
     d INT_LoadAddFields...                                                                                             
     d                 pr                                                                                               
                                                                                                                        
     d INT_LoadEditFields...                                                                                            
     d                 pr                                                                                               
     d  PR_InFileName...                                                                                                
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d  PR_InLibraryName...                                                                                             
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
                                                                                                                        
     d INT_ValidInput...                                                                                                
     d                 pr                  Like(StdLgl)                                                                 
     d   PR_InProcessingMode...                                                                                         
     d                                     Like(StdChr)                                                                 
     d                                     Value                                                                        
                                                                                                                        
     d INT_AddRecord...                                                                                                 
     d                 pr                                                                                               
                                                                                                                        
     d INT_EditRecord...                                                                                                
     d                 pr                                                                                               
     d   PR_InFileName...                                                                                               
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d   PR_InLibraryName...                                                                                            
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
                                                                                                                        
      /copy *libl/qsrcf,CB_MAP_IND                                                                                      
     d ErrorOnFileName...                                                                                               
     d                                     Like(StdLgl)                                                                 
     d                                     OverLay(GenericIN50)                                                         
     d ErrorOnLibraryName...                                                                                            
     d                                     Like(StdLgl)                                                                 
     d                                     OverLay(GenericIN51)                                                         
     d ErrorOnServiceProgramName...                                                                                     
     d                                     Like(StdLgl)                                                                 
     d                                     OverLay(GenericIN52)                                                         
     d ErrorOnServiceLibraryName...                                                                                     
     d                                     Like(StdLgl)                                                                 
     d                                     OverLay(GenericIN53)                                                         
     d ErrorOnServiceProcedure...                                                                                       
     d                                     Like(StdLgl)                                                                 
     d                                     OverLay(GenericIN54)                                                         
     d AddRecordMode...                                                                                                 
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN81)                                                         
     d EditRecordMode...                                                                                                
     d                                     Like(StdLgl)                                                                 
     d                                     overlay(GenericIN82)                                                         
     d DisplayRecordMode...                                                                                             
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN83)                                                         
     d DisplaySubfileEndOnSubfileMessageQueue...                                                                        
     d                                     Like(StdLgl)                                                                 
     d                                     OverLay(GenericIN95)                                                         
                                                                                                                        
     d ProgramName...                                                                                                   
     d                 s                   Like(StdNam)                                                                 
     d                                     Import                                                                       
     *--------------------------------------------------------------                                                   
     * File information data structure for display file one.                                                           
     d FI01...                                                                                                          
     d                 ds                  Qualified                                                                    
     d   KeyPressed...                                                                                                  
     d                       369    369                                                                                 
                                                                                                                        
     d SystemDataStructure...                                                                                           
     d                sds           333    Qualified                                                                    
     d   ModuleName...                                                                                                  
     d                         1     10                                                                                 
     d   UserName...                                                                                                    
     d                       254    263                                                                                 
                                                                                                                        
     d cMainProcedureName...                                                                                            
     d                 c                   Const('PROCESSSCREEN04')                                                     
     d cAddRecordMode...                                                                                                
     d                 c                   Const('A')                                                                   
     d cEditRecordMode...                                                                                               
     d                 c                   Const('E')                                                                   
     d cDisplayRecordMode...                                                                                            
     d                 c                   Const('D')                                                                   
                                                                                                                        
      /copy *libl/qsrcf,CB_KEYP                                                                                         
                                                                                                                        
     d ScreenOpen      s                   Like(StdLgl)                                                                 
     d                                     Inz(cFalse)                                                                  
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * ProcessScreen04                                                                                                 
     *  Do processing for Screen 4 - Standard Add/Edit/Display Panel.                                                  
     *   Input     - File Name to Edit/Display.                                                                        
     *               Processing Mode.                                                                                  
     *   Out       - None.                                                                                             
     *   Returns   - Key Pressed to end screen.                                                                        
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p ProcessScreen04...                                                                                               
     p                 b                   Export                                                                       
     d                 pi                  Like(StdChr)                                                                 
     d   InFileName...                                                                                                  
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d   InLibraryName...                                                                                               
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d   InProcessingMode...                                                                                            
     d                                     Like(StdChr)                                                                 
     d                                     Value                                                                        
                                                                                                                        
      /Free                                                                                                             
                                                                                                                        
         If Not ScreenOpen;                                                                                             
           ScreenOpen = cTrue;                                                                                          
           Open TG0002_D01;                                                                                             
           Open TGCTRLD_00;                                                                                             
         EndIf;                                                                                                         
                                                                                                                        
         Select;                                                                                                        
           When InProcessingMode = cAddRecordMode;                                                                      
             INT_LoadAddFields();                                                                                       
           When InProcessingMode = cEditRecordMode;                                                                     
             INT_LoadEditFields(InFileName:InLibraryName);                                                              
         EndSl;                                                                                                         
                                                                                                                        
         MSGF_ClearProgramMessageQueue(cMainProcedureName            :                                                  
                                       SystemDataStructure.ModuleName:                                                  
                                       ProgramName                   );                                                 
                                                                                                                        
         DoU 0 = 1;                                                                                                     
                                                                                                                        
           DisplaySubfileMessages();                                                                                    
                                                                                                                        
           Select;                                                                                                      
             When InProcessingMode = cAddRecordMode;                                                                    
               AddRecordMode = cTrue;                                                                                   
             When InProcessingMode = cEditRecordMode;                                                                   
               EditRecordMode = cTrue;                                                                                  
             When InProcessingMode = cDisplayRecordMode;                                                                
               DisplayRecordMode = cTrue;                                                                               
           EndSl;                                                                                                       
                                                                                                                        
           ExFmt RD01_04;                                                                                               
                                                                                                                        
           MSGF_ClearProgramMessageQueue(cMainProcedureName            :                                                
                                         SystemDataStructure.ModuleName:                                                
                                         ProgramName                   );                                               
                                                                                                                        
           MSGF_ClearErrorIndicators(*IN                  :                                                             
                                     cStartErrorIndicators:                                                             
                                     cEndErrorIndicators  );                                                            
                                                                                                                        
           AddRecordMode     = cFalse;                                                                                  
           EditRecordMode    = cFalse;                                                                                  
           DisplayRecordMode = cFalse;                                                                                  
                                                                                                                        
           // Process based on key pressed.                                                                             
           Select;                                                                                                      
             When FI01.KeyPressed = F3 or                                                                               
                  FI01.KeyPressed = F12;                                                                                
               Return FI01.KeyPressed;                                                                                  
             Other;                                                                                                     
                                                                                                                        
             If InProcessingMode = cDisplayRecordMode;                                                                  
               Return FI01.KeyPressed;                                                                                  
             EndIf;                                                                                                     
                                                                                                                        
             If Not INT_ValidInput(InProcessingMode);                                                                   
               Iter;                                                                                                    
             EndIf;                                                                                                     
                                                                                                                        
             // If no errors, update database.                                                                          
             Select;                                                                                                    
               When InProcessingMode = cAddRecordMode;                                                                  
                 INT_AddRecord();                                                                                       
               When InProcessingMode = cEditRecordMode;                                                                 
                 INT_EditRecord(InFileName:InLibraryName);                                                              
             EndSl;                                                                                                     
                                                                                                                        
             // If edit mode, return to caller.                                                                         
             If InProcessingMode = cEditRecordMode;                                                                     
               Return Enter;                                                                                            
             EndIf;                                                                                                     
                                                                                                                        
             // If Add mode, clear fields and get another record for add.                                               
             INT_LoadAddFields();                                                                                       
             Iter;                                                                                                      
           EndSl;                                                                                                       
         EndDo;                                                                                                         
 001                                                                                                                    
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * CloseScreen04                                                                                                   
     *   Input     - None                                                                                              
     *   Out       - None                                                                                              
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p CloseScreen04...                                                                                                 
     p                 b                   Export                                                                       
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         Close TG0002_D01;                                                                                              
         Close TGCTRLD_00;                                                                                              
         ScreenOpen = cFalse;                                                                                           
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_LoadAddFields                                                                                               
     *  Load add screen fields.                                                                                        
     *   Input     - None.                                                                                             
     *   Out       - None.                                                                                             
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_LoadAddFields...                                                                                             
     p                 b                                                                                                
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         B_FILENAME = *Blanks;                                                                                          
         B_LIBNAME  = *Blanks;                                                                                          
         B_ACTIVE   = cYes;                                                                                             
         B_SRVPGM   = *Blanks;                                                                                          
         B_SRVLIB   = *Blanks;                                                                                          
         B_SRVPROC  = *Blanks;                                                                                          
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_LoadEditFields                                                                                              
     *  Load edit screen fields.                                                                                       
     *   Input     - None.                                                                                             
     *   Out       - None.                                                                                             
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_LoadEditFields...                                                                                            
     p                 b                                                                                                
     d                 pi                                                                                               
     d  InFileName...                                                                                                   
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d  InLibraryName...                                                                                                
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
      /Free                                                                                                             
                                                                                                                        
         Chain(n) (InFileName:InLibraryName) TGCTRLD_00;                                                                
         If %Found(TGCTRLD_00);                                                                                         
           B_FILENAME = TDFILENAME;                                                                                     
           B_LIBNAME  = TDLIBNAME;                                                                                      
           B_ACTIVE   = TDACTIVE;                                                                                       
           B_SRVPGM   = TDSRVPGM;                                                                                       
           B_SRVLIB   = TDSRVLIB;                                                                                       
           B_SRVPROC  = TDSRVPROC;                                                                                      
           O_CRTDATE  = %Char(%Date(TDCRTSTAMP):*USA/);                                                                 
           O_CRTTIME  = %Char(%Time(TDCRTSTAMP):*HMS:);                                                                 
           O_CRTUSER  = TDCRTUSER;                                                                                      
           O_EDTDATE  = %Char(%Date(TDEDTSTAMP):*USA/);                                                                 
           O_EDTTIME  = %Char(%Time(TDEDTSTAMP):*HMS:);                                                                 
           O_EDTUSER  = TDEDTUSER;                                                                                      
         Else;                                                                                                          
           B_FILENAME = *All'?';                                                                                        
           B_LIBNAME  = *All'?';                                                                                        
           B_ACTIVE   = cNo;                                                                                            
           B_SRVPGM   = *All'?';                                                                                        
           B_SRVLIB   = *All'?';                                                                                        
           B_SRVPROC  = *All'?';                                                                                        
           O_CRTDATE  = *All'?';                                                                                        
           O_CRTTIME  = *All'?';                                                                                        
           O_CRTUSER  = *All'?';                                                                                        
           O_EDTDATE  = *All'?';                                                                                        
           O_EDTTIME  = *All'?';                                                                                        
           O_EDTUSER  = *All'?';                                                                                        
         EndIf;                                                                                                         
                                                                                                                        
         Return;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_ValidInput                                                                                                  
     *  Validate input.                                                                                                
     *   Input     - None.                                                                                             
     *   Out       - None.                                                                                             
     *   Returns   - True if ok. False if no ok.                                                                       
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_ValidInput...                                                                                                
     p                 b                                                                                                
     d                 pi                  Like(StdLgl)                                                                 
     d   InProcessingMode...                                                                                            
     d                                     Like(StdChr)                                                                 
     d                                     Value                                                                        
                                                                                                                        
     d IsValid...                                                                                                       
     d                 s                   Like(StdLgl)                                                                 
     d                                     Inz(cTrue)                                                                   
     d MsgUGP0001...                                                                                                    
     d                 ds                  Qualified                                                                    
     d   FieldName...                                                                                                   
     d                              100    Varying                                                                      
      /Free                                                                                                             
                                                                                                                        
         If B_FILENAME = *Blanks or                                                                                     
            B_FILENAME = *All'?';                                                                                       
           IsValid = cFalse;                                                                                            
           ErrorOnFileName = cTrue;                                                                                     
           MsgUGP0001.FieldName = 'File Name';                                                                          
           MSGF_SendProgramMessage('UGP0001'                     :                                                      
                                   cXVMessageFileName            :                                                      
                                   MsgUGP0001                    :                                                      
                                   cMainProcedureName            :                                                      
                                   SystemDataStructure.ModuleName:                                                      
                                   ProgramName                   );                                                     
         EndIf;                                                                                                         
                                                                                                                        
         If B_LIBNAME = *Blanks or                                                                                      
            B_LIBNAME = *All'?';                                                                                        
           IsValid = cFalse;                                                                                            
           ErrorOnLibraryName = cTrue;                                                                                  
           MsgUGP0001.FieldName = 'Library Name';                                                                       
           MSGF_SendProgramMessage('UGP0001'                     :                                                      
                                   cXVMessageFileName            :                                                      
                                   MsgUGP0001                    :                                                      
                                   cMainProcedureName            :                                                      
                                   SystemDataStructure.ModuleName:                                                      
                                   ProgramName                   );                                                     
         EndIf;                                                                                                         
                                                                                                                        
         If B_SRVPGM = *Blanks or                                                                                       
            B_SRVPGM = *All'?';                                                                                         
           IsValid = cFalse;                                                                                            
           ErrorOnServiceProgramName = cTrue;                                                                           
           MsgUGP0001.FieldName = 'Service Program Name';                                                               
           MSGF_SendProgramMessage('UGP0001'                     :                                                      
                                   cXVMessageFileName            :                                                      
                                   MsgUGP0001                    :                                                      
                                   cMainProcedureName            :                                                      
                                   SystemDataStructure.ModuleName:                                                      
                                   ProgramName                   );                                                     
         EndIf;                                                                                                         
                                                                                                                        
         If B_SRVLIB = *Blanks;                                                                                         
           IsValid = cFalse;                                                                                            
           ErrorOnServiceLibraryName = cTrue;                                                                           
           MsgUGP0001.FieldName = 'Service Program Library';                                                            
           MSGF_SendProgramMessage('UGP0001'                     :                                                      
                                   cXVMessageFileName            :                                                      
                                   MsgUGP0001                    :                                                      
                                   cMainProcedureName            :                                                      
                                   SystemDataStructure.ModuleName:                                                      
                                   ProgramName                   );                                                     
         EndIf;                                                                                                         
                                                                                                                        
         If B_SRVPROC = *Blanks or                                                                                      
            B_SRVPROC = *All'?';                                                                                        
           IsValid = cFalse;                                                                                            
           ErrorOnServiceProcedure = cTrue;                                                                             
           MsgUGP0001.FieldName = 'Service Procedure Name';                                                             
           MSGF_SendProgramMessage('UGP0001'                     :                                                      
                                   cXVMessageFileName            :                                                      
                                   MsgUGP0001                    :                                                      
                                   cMainProcedureName            :                                                      
                                   SystemDataStructure.ModuleName:                                                      
                                   ProgramName                   );                                                     
         EndIf;                                                                                                         
                                                                                                                        
         If InProcessingMode = cAddRecordMode;                                                                          
           Setll (B_FILENAME:B_LIBNAME) TGCTRLD_00;                                                                     
           If %Found(TGCTRLD_00);                                                                                       
             IsValid = cFalse;                                                                                          
             ErrorOnFileName    = cTrue;                                                                                
             ErrorOnLibraryName = cTrue;                                                                                
             MSGF_SendProgramMessage('UTG0003'                     :                                                    
                                     cXVMessageFileName            :                                                    
                                     B_FILENAME + B_LIBNAME        :                                                    
                                     cMainProcedureName            :                                                    
                                     SystemDataStructure.ModuleName:                                                    
                                     ProgramName                   );                                                   
           EndIf;                                                                                                       
         EndIf;                                                                                                         
                                                                                                                        
         Return IsValid;                                                                                                
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_AddRecord                                                                                                   
     *  Add Record to Database.                                                                                        
     *   Input     - None.                                                                                             
     *   Out       - None.                                                                                             
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_AddRecord...                                                                                                 
     p                 b                                                                                                
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         TDFILENAME = B_FILENAME;                                                                                       
         TDLIBNAME  = B_LIBNAME;                                                                                        
         TDACTIVE   = B_ACTIVE;                                                                                         
         TDSRVPGM   = B_SRVPGM;                                                                                         
         TDSRVLIB   = B_SRVLIB;                                                                                         
         TDSRVPROC  = B_SRVPROC;                                                                                        
                                                                                                                        
         TDCRTSTAMP = %TimeStamp();                                                                                     
         TDCRTUSER  = SystemDataStructure.UserName;                                                                     
         TDEDTSTAMP = %TimeStamp();                                                                                     
         TDEDTUSER  = SystemDataStructure.UserName;                                                                     
                                                                                                                        
         Write RCTRLD_00;                                                                                               
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_EditRecord                                                                                                  
     *  Update Edit record to database.                                                                                
     *   Input     - None.                                                                                             
     *   Out       - None.                                                                                             
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_EditRecord...                                                                                                
     p                 b                                                                                                
     d                 pi                                                                                               
     d  InFileName...                                                                                                   
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d  InLibraryName...                                                                                                
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
      /Free                                                                                                             
                                                                                                                        
         Chain (InFileName:InLibraryName) TGCTRLD_00;                                                                   
         If %Found(TGCTRLD_00);                                                                                         
           TDFILENAME = B_FILENAME;                                                                                     
           TDLIBNAME  = B_LIBNAME;                                                                                      
           TDACTIVE   = B_ACTIVE;                                                                                       
           TDSRVPGM   = B_SRVPGM;                                                                                       
           TDSRVLIB   = B_SRVLIB;                                                                                       
           TDSRVPROC  = B_SRVPROC;                                                                                      
                                                                                                                        
           TDEDTSTAMP = %TimeStamp();                                                                                   
           TDEDTUSER  = SystemDataStructure.UserName;                                                                   
                                                                                                                        
           Update RCTRLD_00;                                                                                            
         EndIf;                                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
      /Define cb_DisplaySubfileMessages_PI                                                                              
      /copy *libl/qsrcf,CB_DSPSFM                                                                                       
      /Undefine cb_DisplaySubfileMessages_PI                                                                            
